// スクリプト実行状態保持オブジェクト
function ScriptContext() {

	// スクリプトコード実行位置
	this.pos = 0;

	// 実行中コード配列
	this.list = null;

	this.status = ScriptContext.SCRIPTSTATE_NONE;
	this.stage = 0;
	this.if_level = 0;

	this.caller_context = null;

}

ScriptContext.createScriptContext = function(list, context) {

	if (list == null) {
		return null;
	}

	var obj = new ScriptContext();

	var item;

	if (list instanceof ScriptCode) {

		item = new ScriptCode();

		item.name = new String(list.name);
		item.args = list.copyArgs();

		obj.list = new Array();

		obj.list.push(item);

	}

	if (list instanceof Array) {

		obj.list = new Array();

		var i;

		for (i = 0;i < list.length;i++) {

			item = new ScriptCode();

			item.name = new String(list[i].name);
			item.args = list[i].copyArgs();

			obj.list.push(item);

		}

	}

	obj.status = ScriptContext.SCRIPTSTATE_CODELOAD;

	obj.caller_context = context;

	return obj;

}

// スクリプト処理状態
ScriptContext.SCRIPTSTATE_NONE = 0;
ScriptContext.SCRIPTSTATE_CODELOAD = 1;
ScriptContext.SCRIPTSTATE_CODEEXEC = 2;
ScriptContext.SCRIPTSTATE_CODEEXIT = 3;
